# Generated by sila2.code_generator; sila2.__version__: 0.12.2
from __future__ import annotations

from typing import TYPE_CHECKING
from uuid import uuid4
from labdata_aggregator.sila_feature_call_model import SiLAFeatureCalls
import yaml
from logging import getLogger

from sila2.server import MetadataDict

from ..generated.measurementcontroller import (
    UUID,
    LoadFeatureCallConfigurationDB_Responses,
    MeasurementControllerBase,
    SetFeatureCallConfiguration_Responses,
    SetPollingInterval_Responses,
    StartMeasurement_Responses,
    StopMeasurement_Responses,
)

if TYPE_CHECKING:
    from ..server import Server


class MeasurementControllerImpl(MeasurementControllerBase):
    def __init__(self, parent_server: Server) -> None:
        self.parent_server = parent_server

        self.UUID = None

        self.logger = getLogger(__name__)
    
        super().__init__(parent_server=parent_server)

    def get_FeatureCallConfiguration(self, *, metadata: MetadataDict) -> str:
        fc_json = self.parent_server.influxdbcontroller.database_writer.feature_calls.model_dump_json()
        return yaml.dump(yaml.safe_load(fc_json))
    
    def get_PollingInterval(self, *, metadata: MetadataDict) -> float:
        return self.parent_server.influxdbcontroller.database_writer.writing_interval
    
    def get_CurrentMeasurements(self, *, metadata: MetadataDict) -> str:
        raise NotImplementedError  # TODO


    def StartMeasurement(self, Name: str, *, metadata: MetadataDict) -> StartMeasurement_Responses:

        self.UUID = str(uuid4())
        print("-- start measurement - uuid: ", self.UUID)

        self.parent_server.influxdbcontroller.start_measurement(Name)

        return StartMeasurement_Responses(CommandExecutionUUID=self.UUID)

    def StopMeasurement(self, CommandExecutionUUID: UUID, *, metadata: MetadataDict) -> StopMeasurement_Responses:
        # TODO check for UUID !
        self.parent_server.influxdbcontroller.stop_measurement()

        return StopMeasurement_Responses()

    def SetPollingInterval(self, Interval: float, *, metadata: MetadataDict) -> SetPollingInterval_Responses:
        self.parent_server.influxdbcontroller.database_writer.writing_interval = Interval

        return SetPollingInterval_Responses()

    def LoadFeatureCallConfigurationDB(
        self, LARADatabaseConnector: str, Namespace: str, FeatureCallConfigurationName: str, *, metadata: MetadataDict
    ) -> LoadFeatureCallConfigurationDB_Responses:
        raise NotImplementedError  # TODO

    def SetFeatureCallConfiguration(
        self, FeatureCallConfiguration: str, *, metadata: MetadataDict
    ) -> SetFeatureCallConfiguration_Responses:
        print(f"----------features map {FeatureCallConfiguration}")

        try:
            sila_feature_calls_dict = yaml.safe_load(FeatureCallConfiguration)

            # then create the SiLAFeatureCalls object from the dictionary

            self.parent_server.influxdbcontroller.set_feature_calls(feature_calls=SiLAFeatureCalls(** sila_feature_calls_dict))
        
        except Exception as e:
            self.logger.error(f"Error in SetFeatureCallConfiguration: {e}")
            
       
    # def load_feature_map(self, feature_map_str):
    #     self.parent_server.influxdbcontroller.map_features(known_features_map=yaml.safe_load(feature_map_str) ) 
